<template>
  <div class="login-container">
    <el-card class="form-container">
      <div class="login-title">
        <h2>{{ defaultSettings.title }}</h2>
        <div @click="showJobNumber = !showJobNumber">
          {{ showJobNumber ? "账号密码登录" : "扫码登录" }}
        </div>
      </div>

      <el-form
        ref="loginFormRef"
        :model="loginData"
        :rules="loginRules"
        class="login-form"
        size="large"
      >
        <el-form-item v-if="showJobNumber" prop="jobNumber">
          <div class="flex-y-center w-full">
            <svg-icon class="mx-2" icon-class="document" />
            <el-input
              ref="username"
              v-model="loginData.jobNumber"
              class="h-[48px]"
              name="jobNumber"
              placeholder="请扫码或输入工号"
              size="large"
            />
          </div>
        </el-form-item>
        <div v-else>
          <!-- 用户名 -->
          <el-form-item prop="userName">
            <div class="flex-y-center w-full">
              <svg-icon class="mx-2" icon-class="user" />
              <el-input
                ref="username"
                v-model="loginData.userName"
                class="h-[48px]"
                name="userName"
                placeholder="请输入账号"
                size="large"
              />
            </div>
          </el-form-item>

          <!-- 密码 -->
          <el-tooltip
            :content="$t('login.capsLock')"
            :visible="isCapslock"
            placement="right"
          >
            <el-form-item prop="password">
              <div class="flex-y-center w-full">
                <svg-icon class="mx-2" icon-class="lock" />
                <el-input
                  v-model="loginData.password"
                  :placeholder="$t('login.password')"
                  class="h-[48px] pr-2"
                  name="password"
                  show-password
                  size="large"
                  type="password"
                  @keyup="checkCapslock"
                />
              </div>
            </el-form-item>
          </el-tooltip>
        </div>

        <!-- 组织 -->
        <el-form-item prop="orgId">
          <div class="flex-y-center w-full">
            <svg-icon class="mx-2" icon-class="captcha" />
            <el-select
              v-model="loginData.orgId"
              class="no-border"
              placeholder="请选择组织"
              size="large"
            >
              <el-option
                v-for="item in orgList"
                :key="item.id"
                :label="item.deptName"
                :value="item.id"
              />
            </el-select>
          </div>
        </el-form-item>

        <el-form-item prop="proCode">
          <div class="flex-y-center w-full">
            <svg-icon class="mx-2" icon-class="cascader" />
            <el-select
              v-model="loginData.proCode"
              class="no-border"
              placeholder="请选择产线"
              size="large"
            >
              <el-option
                v-for="item in productionList"
                :key="item.code"
                :label="item.name"
                :value="item.code"
              />
            </el-select>
          </div>
        </el-form-item>

        <el-form-item prop="stationId">
          <div class="flex-y-center w-full">
            <svg-icon class="mx-2" icon-class="client" />
            <el-select
              v-model="loginData.stationId"
              class="no-border"
              placeholder="请选择工位"
              size="large"
              @change="onStationChange"
            >
              <el-option
                v-for="item in stationList"
                :key="item.id"
                :label="item.name"
                :value="item.id"
              />
            </el-select>
          </div>
        </el-form-item>

        <!-- 登录按钮 -->
        <el-button
          :loading="loading"
          class="login-btn"
          size="large"
          type="primary"
          @click.prevent="handleLogin"
          >{{ $t("login.login") }}
        </el-button>
      </el-form>
    </el-card>

    <!-- ICP备案 -->
    <div v-show="icpVisible" class="absolute bottom-1 text-[10px] text-center">
      <p>Copyright © 2022-2025 jgai.com All Rights Reserved.</p>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { useSettingsStore, useUserStore } from "@/store";
import {
  getCaptchaApi,
  getOrgListApi,
  getProductionList,
  stationListByCode,
} from "@/api/auth";
import { LoginData } from "@/api/auth/types";
import { useRoute } from "vue-router";
import defaultSettings from "@/settings";
import { ThemeEnum } from "@/enums/ThemeEnum";
import { watch } from "vue";
import router from "@/router";
// Stores
const userStore = useUserStore();
const settingsStore = useSettingsStore();

// Internationalization
const { t } = useI18n();

// Reactive states
const isDark = ref(settingsStore.theme === ThemeEnum.DARK);
const icpVisible = ref(true);
const showJobNumber = ref(false);
const orgList = ref<any>([]);
const productionList = ref<any>([]);
const stationList = ref<any>([]);
const loading = ref(false); // 按钮loading
const isCapslock = ref(false); // 是否大写锁定
const captchaBase64 = ref(); // 验证码图片Base64字符串
const loginFormRef = ref(ElForm); // 登录表单ref
const { height } = useWindowSize();

const loginData = ref<LoginData>({
  userName: "",
  password: "",
});

const loginRules = computed?.(() => {
  return {
    userName: [
      {
        required: true,
        trigger: "blur",
        message: "请输入账号",
      },
    ],
    password: [
      {
        required: true,
        trigger: "blur",
        message: t("login.message.password.required"),
      },
      {
        min: 6,
        message: t("login.message.password.min"),
        trigger: "blur",
      },
    ],
    orgId: [
      {
        required: true,
        trigger: "blur",
        message: t("login.message.orgId.required"),
      },
    ],
    proCode: [
      {
        required: true,
        trigger: "blur",
        message: "请选择产线",
      },
    ],
    stationId: [
      {
        required: true,
        trigger: "blur",
        message: "请选择工位",
      },
    ],
    jobNumber: [
      {
        required: true,
        trigger: "blur",
        message: "请输入工号",
      },
    ],
  };
});

let stationType = ""; //工位类型
let stationName = ""; //工位名称
const onStationChange = (val: any) => {
  const stationArray = stationList.value.filter((item: any) => {
    return item.id === val;
  });
  stationType = stationArray[0].stationDictValue;
  stationName = stationArray[0].name;
  loginData.value.stationType = stationArray[0].stationDictValue;
};

/**
 * 获取验证码
 */
function getCaptcha() {
  getCaptchaApi().then(({ data }) => {
    loginData.value.captchaKey = data.captchaKey;
    captchaBase64.value = data.captchaBase64;
  });
}

function getOrgList() {
  getOrgListApi().then((data: any) => {
    orgList.value = data.data;
    if (orgList.value) {
      loginData.value.orgId = orgList.value[0].id;
    }
  });
}

/**
 * 登录
 */
const route = useRoute();

function handleLogin() {
  loginFormRef.value.validate((valid: boolean) => {
    if (valid) {
      localStorage.setItem("local_name", loginData.value.userName);
      localStorage.setItem("local_pwd", loginData.value.password);
      loading.value = true;

      let numberP = {
        proCode: loginData.value.proCode,
        orgId: loginData.value.orgId,
        jobNumber: loginData.value.jobNumber,
        stationId: loginData.value.stationId,
        stationType: loginData.value.stationType,
      };

      let acountP = {
        userName: loginData.value.userName,
        password: loginData.value.password,
        proCode: loginData.value.proCode,
        orgId: loginData.value.orgId,
        stationId: loginData.value.stationId,
        stationType: loginData.value.stationType,
      };
      localStorage.setItem("local_stationId", loginData.value.stationId);
      userStore
        .login(showJobNumber.value ? numberP : acountP)
        .then(() => {
          userStore.user.station = stationName;
          userStore.user.proCode = loginData.value.proCode;

          // 捡选 装配 测试 维修站 预齐套
          if (stationType == "5") {
            router.replace({ name: "PrepareMain" });
          } else {
            router.replace({ name: "ProcessMain" });
          }
        })
        .catch(() => {
          // getCaptcha();

          console.log("catch");
        })
        .finally(() => {
          loading.value = false;
        });
    }
  });
}

/**
 * 主题切换
 */

const toggleTheme = () => {
  //const newTheme = settingsStore.theme === ThemeEnum.DARK ? ThemeEnum.LIGHT : ThemeEnum.DARK;
  //settingsStore.changeTheme(newTheme);
};
/**
 * 根据屏幕宽度切换设备模式
 */

watchEffect?.(() => {
  if (height.value < 600) {
    icpVisible.value = false;
  } else {
    icpVisible.value = true;
  }
});

watch(
  () => loginData.value.proCode,
  (newValue) => {
    if (newValue) {
      stationListByCode(newValue).then((data: any) => {
        stationList.value = data.data;
        if (stationList.value && stationList.value.length > 0) {
          let index = 0;
          for (let i = 0; i < stationList.value.length; i++) {
            if (
              localStorage.getItem("local_stationId") ===
              stationList.value[i].id
            ) {
              index = i;
              break;
            }
          }
          let station = stationList.value[index];
          loginData.value.stationId = station.id;
          stationType = station.stationDictValue;
          stationName = station.name;
          loginData.value.stationType = station.stationDictValue;
        }
      });
    }
  }
);

/**
 * 检查输入大小写
 */
function checkCapslock(e: any) {
  isCapslock.value = e.getModifierState("CapsLock");
}

onMounted?.(() => {
  getOrgList();
  toggleTheme();
  getProductionList().then((data: any) => {
    productionList.value = data.data;
    if (productionList.value) {
      loginData.value.proCode = productionList.value[0].code;
    }
  });
  if (
    localStorage.getItem("local_name") &&
    localStorage.getItem("local_name") !== "null"
  ) {
    loginData.value.userName = localStorage.getItem("local_name");
    loginData.value.password = localStorage.getItem("local_pwd");
  }
});
</script>

<style lang="scss" scoped>
//html.dark .login-container {
//  //background: url("@/assets/images/login-bg.png") no-repeat center right;
//}

.login-container {
  overflow-y: auto;
  background: url("@/assets/images/login-bg.png") no-repeat center right;
  background-size: cover;
  position: relative;

  @apply wh-full flex-center;

  .login-form {
    padding: 30px 10px;
  }

  .login-title {
    color: white;
    margin-left: 10px;
    display: flex;
    justify-content: space-between;
    align-items: center;
  }

  .form-container {
    background: #a0a8b2;
    border-radius: 16px;
    width: 673px;
    position: absolute;
    right: 10%;
  }

  .login-btn {
    width: 100%;
    height: 50px;
    border-radius: 25px;
    margin-top: 15px;
  }
}

.el-form-item {
  background: var(--el-input-bg-color);
  border: 1px solid var(--el-border-color);
  border-radius: 5px;
}

:deep(.el-input) {
  .el-input__wrapper {
    padding: 0;
    background-color: transparent;
    box-shadow: none;

    &.is-focus,
    &:hover {
      box-shadow: none !important;
    }

    input:-webkit-autofill {
      /* 通过延时渲染背景色变相去除背景颜色 */
      transition: background-color 1000s ease-in-out 0s;
    }
  }
}

:deep(.el-select__placeholder) {
  color: rgba(0, 0, 0, 0.9);
}

:deep(.el-select__placeholder.is-transparent) {
  color: rgba(0, 0, 0, 0.3);
}

:deep(.el-input__inner::placeholder) {
  color: rgba(0, 0, 0, 0.3);
}

:deep(.el-input__inner) {
  color: rgba(0, 0, 0, 0.9);
}

:deep(.el-select) {
  .el-select__wrapper {
    padding: 0;
    background-color: transparent;
    box-shadow: none;

    &.is-focus,
    &:hover {
      box-shadow: none !important;
    }

    input:-webkit-autofill {
      /* 通过延时渲染背景色变相去除背景颜色 */
      transition: background-color 1000s ease-in-out 0s;
    }
  }
}
</style>
